<?php
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: MAMS (c) 2020-2021 by CMS Made Simple Foundation
#  An add-on module for CMS Made Simple to provide useful functions
#  and commonly used gui capabilities to other modules.
#-------------------------------------------------------------------------
# A fork of:
#
# Module: FrontEndUsers (c) 2008-2014 by Robert Campbell
#         (calguy1000@cmsmadesimple.org)
#
#-------------------------------------------------------------------------
#
# CMSMS - CMS Made Simple is (c) 2006 - 2021 by CMS Made Simple Foundation
# CMSMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# Visit the CMSMS Homepage at: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE

namespace MAMS;
use \mams_utils;

abstract class verification_assistant
{
    protected $mams;
    private $_destpage;

    public function __construct( \MAMS $mod )
    {
        $this->mams = $mod;
    }
    
    private function generate_destpage($uid)
    {
        $dflt = \ContentOperations::get_instance()->GetDefaultContent();
        $page = mams_utils::resolve_preftpl_to_page('pageid_onverify',$uid);
        if( !$page ) $page = $dflt;
        return $page;
    }

    public function get_destpage()
    {
        return $this->_destpage;
    }

    public function set_destpage($str)
    {
        if( $str ) {
            $this->_destpage = $this->mams->resolve_alias_or_id($str,$this->_destpage);
        }
    }

    public function set_force_verify( $uid, $flag = true )
    {
        $uid = (int) $uid;
        if( $uid < 1 ) throw new \InvalidArgumentException( 'Invalid uid passed to '.__METHOD__);
        
        if( $flag ) {
            $code = mams_utils::generate_random_printable_string();
            $this->mams->SetUserTempCode( $uid, $code );
            $this->mams->ForceVerify( $uid, TRUE );
            return $code;
        }
        else {
            $this->mams->RemoveUserTempCode( $uid );
            $this->mams->ForceVerify( $uid, FALSE );
        }
    }
    
    public function get_verify_form_url($uid, $code = null )
    {
        $uid = (int) $uid;
        if( $uid < 1 ) throw new \InvalidArgumentException( 'Invalid uid passed to '.__METHOD__);
        $code = trim($code);
        if( !$code ) $code = 'xxxx';
        
        $destpage = $this->_destpage;
        if( !$destpage ) $destpage = $this->generate_destpage($uid);
        $url = $this->mams->create_url('cntnt01','verifyonly',$destpage,[ 'uid'=>$uid, 'code'=>$code ] );
        $url = str_replace( 'amp;', '', $url );
        return $url;
    }

    abstract public function send( $uid, $code );
    
}
